diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Inline32int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline32int.java
@@ -0,0 +1,121 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ32int;
+import org.openjdk.bench.valhalla.types.ByInt;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline32int extends StatesQ32int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_fields(Val_as_Val st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_fields(Val_as_Ref st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_fields(Ref_as_Ref st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_sum(Val_as_Val st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_sum(Val_as_Ref st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_sum(Ref_as_Ref st) {
+        int s = 0;
+        Q32int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_sum(Val_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(By_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64byte.java
@@ -0,0 +1,142 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64byte;
+import org.openjdk.bench.valhalla.types.ByByte;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64byte extends StatesQ64byte {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Val_as_Val_fields(Val_as_Val st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v0.v1;
+            s += arr[i].v0.v2;
+            s += arr[i].v0.v3;
+            s += arr[i].v1.v0;
+            s += arr[i].v1.v1;
+            s += arr[i].v1.v2;
+            s += arr[i].v1.v3;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Val_as_Ref_fields(Val_as_Ref st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v0.v1;
+            s += arr[i].v0.v2;
+            s += arr[i].v0.v3;
+            s += arr[i].v1.v0;
+            s += arr[i].v1.v1;
+            s += arr[i].v1.v2;
+            s += arr[i].v1.v3;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Ref_as_Ref_fields(Ref_as_Ref st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v0.v1;
+            s += arr[i].v0.v2;
+            s += arr[i].v0.v3;
+            s += arr[i].v1.v0;
+            s += arr[i].v1.v1;
+            s += arr[i].v1.v2;
+            s += arr[i].v1.v3;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Val_as_Val_sum(Val_as_Val st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].byteSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Val_as_Ref_sum(Val_as_Ref st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].byteSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte Ref_as_Ref_sum(Ref_as_Ref st) {
+        byte s = 0;
+        Q64byte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].byteSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_sum(Val_as_By st) {
+        int s = 0;
+        ByByte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].byteSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(By_as_By st) {
+        int s = 0;
+        ByByte[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].byteSum();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline64int.java
@@ -0,0 +1,135 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64int;
+import org.openjdk.bench.valhalla.types.ByInt;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64int extends StatesQ64int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_fields(Val_as_Val st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_fields(Val_as_Ref st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_fields(Ref_as_Ref st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0;
+            s += arr[i].v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_sum(Val_as_Val st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_sum(Val_as_Ref st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_sum(Ref_as_Ref st) {
+        int s = 0;
+        Q64int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_sum(Val_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Int_sum(Ref_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(By_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/InlineOpt.java b/test/micro/org/openjdk/bench/valhalla/array/sum/InlineOpt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/InlineOpt.java
@@ -0,0 +1,122 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesQOpt;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.Opt;
+import org.openjdk.bench.valhalla.types.QOpt;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class InlineOpt extends StatesQOpt {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_fields(Val_as_Val st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].value.intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_fields(Val_as_Ref st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].value.intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_fields(Ref_as_Ref st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].value.intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_sum(Val_as_Val st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_sum(Val_as_Ref st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_sum(Ref_as_Ref st) {
+        int s = 0;
+        QOpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_sum(Val_as_Int st) {
+        int s = 0;
+        Opt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(Int_as_Int st) {
+        int s = 0;
+        Opt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive128int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive128int.java
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive128int extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int sum(Primitive128int st) {
+        int s = 0;
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            s += values[i];
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive32int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive32int.java
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive32int extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int sum(Primitive32int st) {
+        int s = 0;
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            s += values[i];
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64byte.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64byte.java
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64byte extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public byte sum(Primitive64byte st) {
+        byte s = 0;
+        byte[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            s += values[i];
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64int.java
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64int extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int sum(Primitive64int st) {
+        int s = 0;
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            s += values[i];
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64long.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Primitive64long.java
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64long extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long sum0(Primitive64long st) {
+        long s = 0;
+        long[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            s += values[i];
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public long sum1(Primitive64long st) {
+        long s = 0;
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            s += st.arr[i];
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/util/PrimitiveStates.java b/test/micro/org/openjdk/bench/valhalla/array/util/PrimitiveStates.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/util/PrimitiveStates.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.util;
+
+import org.openjdk.bench.valhalla.util.SizeBase;
+import org.openjdk.jmh.annotations.Setup;
+
+public class PrimitiveStates extends SizeBase {
+
+    public static abstract class ByteState extends SizeState {
+        public byte[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = (byte) i;
+            }
+        }
+    }
+
+    public static abstract class IntState extends SizeState {
+        public int[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = i;
+            }
+        }
+    }
+
+    public static abstract class LongState extends SizeState {
+        public long[] arr;
+        void fill() {
+            for (int i = 0; i < arr.length; i++) {
+                arr[i] = i;
+            }
+        }
+    }
+
+    public static class Primitive32int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new int[size];
+            fill();
+        }
+    }
+
+    public static class Primitive64byte extends ByteState {
+        @Setup
+        public void setup() {
+            arr = new byte[size * 8];
+            fill();
+        }
+    }
+
+    public static class Primitive64int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new int[size * 2];
+            fill();
+        }
+    }
+
+    public static class Primitive64long extends LongState {
+        @Setup
+        public void setup() {
+            arr = new long[size];
+            fill();
+        }
+    }
+
+    public static class Primitive128int extends IntState {
+        @Setup
+        public void setup() {
+            arr = new int[size * 4];
+            fill();
+        }
+    }
+
+
+}
